----
-- $Rev: 62 $:     Revision der letzten Änderung
-- $Author: FoxAlpha $:  Author der letzten Änderung
-- $Date: 2014-11-20 20:32:10 +0100 (Do, 20. Nov 2014) $:    Date der letzten Änderung
----

----
--	ClockMod v1.2 by Fox-Alpha (c)2014
----

print("|| " .. g_i18n:getText("clockmodtxt") .. " || loading Clock-MOD for LS2013 ||");


ClockMod = {};
ClockMod.moddir		= g_currentModDirectory;
ClockMod.modName 	= g_currentModName;


source(g_currentModDirectory .. "clockmodconfiguration.lua");
source(g_currentModDirectory .. "clockmodconsole.lua");


function ClockMod:loadMap(name)
	self.startzeit = getTime();
	self.Debug = {};
	self.Debug.active = true;

	self.language = g_languageShort;
	self.counter = true;
	
	self.cmEnabled = true;
	
	self.cmVersion = 0;
	
	if g_i18n:hasText("cmTimeFormat") then
		self.timeform = g_i18n:getText("cmTimeFormat");
	else
		self.timeform = 12;
	end;
	
	self.activePlayerNode=0;
	
	----
	-- ClockMod Version ermitteln suchen
	----
	ClockMod.cmVersion = 0;

	local mods = g_currentMission.missionDynamicInfo.mods;

	local beg, ende = 0, 0;
	local cpid = 0;			-- ID von CoursePlay
	local rafid = 0;		-- ID von RentaField

	for i=1, table.getn(mods) do
		beg, ende = string.find(string.lower(mods[i].modName), "clockmod");
		if beg ~= nil and ende ~= nil then
			ClockMod.cmVersion = tostring(mods[i].title) .. " " .. tostring(mods[i].version);
			break;
		end;
	end;
	----
	--	Tabelle für Textfarben
	----
	self.txtColors ={};
	--[[
	self.txtColors.date ={r=1, g=1, b=1, a=1};
	self.txtColors.time ={r=1, g=1, b=1, a=1};
	self.txtColors.title ={r=1, g=1, b=1, a=1};
	self.txtColors.data ={r=1, g=1, b=1, a=1};
	self.txtColors.compass ={r=1, g=1, b=1, a=1};
	]]
	----
	
	----
	-- Tabelle für Wecker
	---
	--[[
	self.cmAlarm = {};
	self.cmAlarm.time = {hour=0, minute=0, enabled=false};
	self.cmAlarm.soundfile = 0;
	---
	]]
	
	----
	-- Tabelle für Counter
	---
	--[[
	self.cmCounter = {};
	self.cmCounter.time = {minute=0, enabled=false};
	self.cmCounter.soundfile = 0;
	---
	]]
	
	----
	--	Paneltables Daten Initialisieren
	----
	self.cmPanel = {};
	self.cmPanel.text = {};
	self.cmPanel.title = {};
	-- self.cmPanel.indent = {date=0.008, time=0.007813, data=0.115, title=0.007813, compass=0.060000};
	self.cmPanel.indent = {};
	-- self.cmPanel.fontsize = {date=0.019, time=0.026, data=0.017, title=0.017, compass=0.026};
	self.cmPanel.fontsize = {};
	self.cmPanel.usePanel = false;
	self.cmPanel.showPanel= false;
	self.cmPanel.usePanelCompass = false;
	-- self.cmPanel.position = {x=0.630000, y=0.895000, w=0.175000};
	self.cmPanel.position = {};
	-- self.cmPanel.files = {	fileTop	 =	{valid=false, file=Utils.getFilename("panel/panelTop.dds", 				self.moddir), height=0.007813, 	overlayID=0}, 
							-- fileMid  =	{valid=false, file=Utils.getFilename("panel/panelMid.dds", 				self.moddir), height=0.0625, 	overlayID=0}, 
							-- fileComp =	{valid=false, file=Utils.getFilename("panel/panelBottomKompass2.dds", 	self.moddir), height=0.050000, overlayID=0}, 
							-- fileBot  =	{valid=false, file=Utils.getFilename("panel/panelBottom.dds",			self.moddir), height=0.007813, 	overlayID=0}
						-- };
	self.cmPanel.files = {};
	----

	----
	--	Base des Panels für Test auf Mausklick
	----
	self.cmPanel.base = {X=0, Y=0};
	self.cmPanel.panelHeight = 0;
	self.cmPanel.hudCanMove = false;
	----
	
	----
	-- Standardwerte zwischenspeichern
	-- ClockModDefault nutz diese Werte um den ClockMod zurück zusetzen
	-- Diese Werte werden beim ersten Start in die XML geschrieben
	----
	self.default = {};
	
	self.default.colors = {};
	self.default.colors.date 	=	{r=1, g=1, b=1, a=1};
	self.default.colors.time 	=	{r=0, g=0, b=0, a=1};
	self.default.colors.title 	=	{r=0, g=0, b=0, a=1};
	self.default.colors.data 	=	{r=0, g=0, b=0, a=1};
	self.default.colors.compass =	{r=1, g=1, b=1, a=1};
	
	self.default.panel = {};
	----
	--	Base des Panels für Test auf Mausklick
	----
	self.default.panel.base = {X=0, Y=0};
	self.default.panel.panelHeight = 0;
	self.default.panel.hudCanMove = false;
	----
	self.default.panel.text = {};
	self.default.panel.title = {};
		if g_i18n:hasText("cmPlayTimeAll") then
			self.cmPanel.title.PlayTimeAll = g_i18n:getText("cmPlayTimeAll");
			self.cmPanel.title.PlayTimeToday = g_i18n:getText("cmPlayTimeToday");
		else -- other
			self.cmPanel.title.PlayTimeAll = "Total time:";
			self.cmPanel.title.PlayTimeToday = "Session time:";
		end
	self.default.panel.indent 			= {date=0.008, time=0.007813, data=0.115, title=0.007813, compass=0.065};	--	Texteinzug/position im Panel
	self.default.panel.fontsize 		= {date=0.019, time=0.026, 	data=0.017, title=0.017, 	compass=0.024};		--	Schriftgrößen
	self.default.panel.usePanel 		= false;	--	Panel wird standard nicht angezeigt. Werte in der GameUhr zu sehen
	self.default.panel.usePanelCompass 	= false;	--	Es wird kein Kompass im Panel angezeigt wenn der Spieler sich in einem Fahrzeug befindet
	self.default.panel.showCompass 		= false;	--	Steuert die Anzeige des Kompass.
	self.default.panel.position 		= {x=0.630000, y=0.895000, w=0.175000};		-- Position des Panels
	--	Attribute für Grafikdateien
	self.default.panel.files = {fileTop  =	{valid=false, file=Utils.getFilename("panel/panelTop.dds", 				self.moddir), height=0.007813, overlayID=0},
								fileMid  =	{valid=false, file=Utils.getFilename("panel/panelMid.dds", 				self.moddir), height=0.079000, overlayID=0}, 
								fileComp =	{valid=false, file=Utils.getFilename("panel/panelBottomKompass.dds", 	self.moddir), height=0.040000, overlayID=0}, 
								fileBot  =	{valid=false, file=Utils.getFilename("panel/panelBottom.dds", 			self.moddir), height=0.007813, overlayID=0}};
	----
	
	--[[
	self.default.alarm = {};
	self.default.alarm.time = {hour=0, minute=0, enabled=false};
	self.default.alarm.soundfile = 0;

	self.default.timer = {};
	self.default.timer.time = {minute=0, enabled=false};
	self.default.timer.soundfile = 0;
	----
	]]
	
	----
	--	Deutsche Monate und Wochentage
	----
	--	TODO: Übersetzungen in ModDesc auslagern
	----
	self.months = {};
    self.months[01] = "Jan";
    self.months[02] = "Feb";
    self.months[03] = "Maer";
    self.months[04] = "Apr";
    self.months[05] = "Mai";
    self.months[06] = "Jun";
    self.months[07] = "Jul";
    self.months[08] = "Aug";
    self.months[09] = "Sep";
    self.months[10] = "Okt";
    self.months[11] = "Nov";
    self.months[12] = "Dez";

	self.days = {};
	self.days[1] = "Sonntag";
	self.days[2] = "Montag";
	self.days[3] = "Dienstag";
	self.days[4] = "Mittwoch";
	self.days[5] = "Donnerstag";
	self.days[6] = "Freitag";
	self.days[7] = "Samstag";
	----
	
	self.de_tag = self.days[tonumber(getDate("%w"))+1];
	self.curmon = getDate("%m")
	self.de_monat = self.months[tonumber(self.curmon)];

	local ptmd = string.gsub(self.moddir, self.modName.."/", "");
	local xmlfile = ptmd .. "ClockModConfig.xml";
	local xmlexists = fileExists(xmlfile);

	----
	--	Wenn noch keine XML vorhanden ist, zum Beispiel bei erster Verwendung
	--	Werte auf Default setzen und in XML speichern
	----
	self.txtColors = nil;
	self.txtColors = {};
	self.txtColors = table.tcopy(self.default.colors);
	self.cmPanel = nil;
	self.cmPanel = {};
	self.cmPanel = table.tcopy(self.default.panel);
	----
	if xmlexists ~= true then
		self:createClockModConfig();
	end;
	----
	self:loadClockModConfig();
	----
	
	----
	-- Registrieren der Konsolen Befehle
	----
	self:registerConsoleCmd();
	----

	----
	--	Erzeugen der Overlays aus den aktualisierten Angaben
	----
	if self.cmPanel.usePanel then
		self:updatePanelOverlays();
	end;
	----
end;

function ClockMod:update(dt)
	-- Ist der Spieler bereits geladen ?
	if self.activePlayerNode == nil or self.activePlayerNode == 0 then
		-- Wenn ja
		if g_currentMission.player ~= nil then
			self.activePlayerNode=g_currentMission.player.rootNode;
		end;
	end;		
	if self.cmPanel.usePanel and self.cmEnabled then
		if self.dragHUD == true and self.cmPanel.hudCanMove then
			----
			--	Update der Panel Position
			--	print("dragHUD ist aktiv, Panel Position aktualisieren | update()");
			----
			self.cmPanel.panelHeight = self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height + self.cmPanel.files.fileTop.height;
			self.cmPanel.position.x = self.cmPanel.base.X - self.cmPanel.position.w/2
			self.cmPanel.position.y = self.cmPanel.base.Y - self.cmPanel.panelHeight/2
			----
		end;
	end;
end;

function ClockMod:draw()
	if self.cmEnabled then
		self.cmPanel.showCompass = not g_currentMission.player.isControlled;
		----
		-- Datum anzeigen / Show Date
		----
		if self.language == "en" then
			self.cmPanel.text.Datetxt = getDate("%a, %d.%b %Y");
		elseif self.language == "de" then
			self.cmPanel.text.Datetxt = (self.de_tag..", "..getDate("%d").."."..self.de_monat.." "..getDate("%Y"));
		else
			self.cmPanel.text.Datetxt = getDate("%a, %d.%b %Y");
		end;
		----
		
		----
		-- Uhrzeit anzeigen / Show Time
		----
		if tonumber(self.timeform) == 12 then
			self.cmPanel.text.Timetxt = getDate("%I:%M:%S ")..string.lower(getDate("%p"));
		elseif tonumber(self.timeform) == 24 then
			self.cmPanel.text.Timetxt = getDate("%H:%M:%S");
		else
			self.cmPanel.text.Timetxt = getDate("%I:%M:%S ")..string.lower(getDate("%p"));
		end
		----
		
		----
		-- Spielzeit zeigen / Show Playtime
		----
		if self.counter then
			if g_i18n:hasText("cmPlayTimeAll") then
				self.cmPanel.title.PlayTimeAll = g_i18n:getText("cmPlayTimeAll");
				self.cmPanel.title.PlayTimeToday = g_i18n:getText("cmPlayTimeToday");
			else -- other
				self.cmPanel.title.PlayTimeAll = "all Playtime:";
				self.cmPanel.title.PlayTimeToday = "Played today:";
			end

			self.playhours = math.floor(g_currentMission.missionStats.playTime /60)
			self.playmins = g_currentMission.missionStats.playTime - (self.playhours * 60)

			if self.playmins >= 10 then
				self.cmPanel.text.PlayTimeAll = (string.format("%.0f", self.playhours)..":"..string.format("%.0f", self.playmins));
			else
				self.cmPanel.text.PlayTimeAll = (string.format("%.0f", self.playhours)..":0"..string.format("%.0f", self.playmins));
			end

			self.playhourssession = math.floor(g_currentMission.missionStats.playTimeSession /60)
			self.playminssession = g_currentMission.missionStats.playTimeSession - (self.playhourssession * 60)

			if self.playminssession >= 10 then
				self.cmPanel.text.PlayTimeToday = (string.format("%.0f", self.playhourssession)..":"..string.format("%.0f", self.playminssession));
			else
				self.cmPanel.text.PlayTimeToday = (string.format("%.0f", self.playhourssession)..":0"..string.format("%.0f", self.playminssession));
			end

		end;
		----
		
		----
		--	Panel erstellen
		----
		if self.cmPanel.usePanel then
			----
			--	Obere Panelgrafik
			----
			local panelBottHeight = 0;
			if self.cmPanel.usePanelCompass and self.cmPanel.showCompass then
				panelBottHeight = self.cmPanel.files.fileComp.height;
			else
				panelBottHeight = self.cmPanel.files.fileBot.height;
			end;
		
			if self.cmPanel.files.fileTop.overlayID ~= nil and self.cmPanel.files.fileTop.overlayID ~=0 then
				renderOverlay(	self.cmPanel.files.fileTop.overlayID,
								self.cmPanel.position.x, 
								self.cmPanel.position.y+self.cmPanel.files.fileMid.height+panelBottHeight, 
								-- self.cmPanel.position.y+self.cmPanel.files.fileMid.height+self.cmPanel.files.fileBot.height, 
								self.cmPanel.position.w, 
								self.cmPanel.files.fileTop.height);
			else
				if self.cmPanel.files.fileTop.valid then
					print("Obere Panelgrafik ist ungültig");
					self.cmPanel.files.fileTop.valid = false;
				end;
			end;
			----
							
			----
			--	Mittlere Panelgrafik
			----
			if self.cmPanel.files.fileMid.overlayID ~= nil and self.cmPanel.files.fileMid.overlayID ~=0 then
				renderOverlay(	self.cmPanel.files.fileMid.overlayID, 
								self.cmPanel.position.x, 
								self.cmPanel.position.y+panelBottHeight, 
								-- self.cmPanel.position.y+self.cmPanel.files.fileBot.height, 
								self.cmPanel.position.w, 
								self.cmPanel.files.fileMid.height);
			else
				if self.cmPanel.files.fileMid.valid then
					print("Mittlere Panelgrafik ist ungültig");
					self.cmPanel.files.fileMid.valid = false;
				end;
			end;
			----

			----
			--	Untere Panelgrafik
			----
			--	Compass Grafik anzeigen
			----
			if self.cmPanel.usePanelCompass and self.cmPanel.showCompass then
				if self.cmPanel.files.fileComp.overlayID ~= nil and self.cmPanel.files.fileComp.overlayID ~=0 then
					renderOverlay(	self.cmPanel.files.fileComp.overlayID, 
									self.cmPanel.position.x, 
									self.cmPanel.position.y, 
									self.cmPanel.position.w, 
									self.cmPanel.files.fileComp.height);
				else
					if self.cmPanel.files.fileComp.valid then
						print("Untere Panelgrafik ist ungültig");
						self.cmPanel.files.fileComp.valid = false;
					end;
				end;
			----
			else	--	Normale Grafik anzeigen
			----
				if self.cmPanel.files.fileBot.overlayID ~= nil and self.cmPanel.files.fileBot.overlayID ~=0 then
					renderOverlay(	self.cmPanel.files.fileBot.overlayID, 
									self.cmPanel.position.x, 
									self.cmPanel.position.y, 
									self.cmPanel.position.w, 
									self.cmPanel.files.fileBot.height);
				else
					if self.cmPanel.files.fileBot.valid then
						print("Untere Panelgrafik ist ungültig");
						self.cmPanel.files.fileBot.valid = false;
					end;
				end;
			end;
			----
							
			----
			--	Texte im Panel darstellen
			--	Sicherstellen der TextAttribute
			----
			setTextAlignment(RenderText.ALIGN_LEFT);
			setTextBold(false)
			----

			----
			--  Datum ausgeben
			----
			setTextColor(self.txtColors.date.r,self.txtColors.date.g,self.txtColors.date.b,self.txtColors.date.a);
			----
			-- local tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date;
			local tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date;
			
			renderText(self.cmPanel.position.x + self.cmPanel.indent.date,
						tY, self.cmPanel.fontsize.date, 
						self.cmPanel.text.Datetxt);
			----

			----
			--  Uhrzeit
			----
			setTextColor(self.txtColors.time.r, self.txtColors.time.g, self.txtColors.time.b, self.txtColors.time.a);
			----
			-- tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time;
			tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.time,
						tY, self.cmPanel.fontsize.time, 
						self.cmPanel.text.Timetxt);
			----

			----
			--  Ausgeben der gespielten Zeit
			----
			--	Farbe Beschriftung
			----
			setTextColor(self.txtColors.title.r, self.txtColors.title.g, self.txtColors.title.b, self.txtColors.title.a);
			----
			--	Spielzeit gesamt
			----
			-- tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title;
			tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.title,
						tY, self.cmPanel.fontsize.title, 
						self.cmPanel.title.PlayTimeAll);
			----
			--	Spielzeit heute
			----
			-- tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height  - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title - self.cmPanel.fontsize.title;
			tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height  - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title - self.cmPanel.fontsize.title;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.title,
						tY, self.cmPanel.fontsize.title, 
						self.cmPanel.title.PlayTimeToday);
						
			----
			--	Farbe Daten
			----
			setTextColor(self.txtColors.data.r, self.txtColors.data.g, self.txtColors.data.b, self.txtColors.data.a);
			----
			--	Daten, Spielzeit gesamt
			----
			-- tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data;
			tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.data,
						tY, self.cmPanel.fontsize.data, 
						self.cmPanel.text.PlayTimeAll);
			----
			--	Daten, Spielzeit heute
			----
			-- tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data - self.cmPanel.fontsize.data;
			tY = self.cmPanel.position.y + panelBottHeight + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data - self.cmPanel.fontsize.data;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.data,
						tY, self.cmPanel.fontsize.data, 
						self.cmPanel.text.PlayTimeToday);
			----
			--	Kompass anzeigen
			----
			self.activePlayerNode=g_currentMission.player.rootNode;
			if self.cmPanel.usePanelCompass and self.cmPanel.showCompass then	
				if not g_currentMission.player.isControlled then
					local plyname = g_currentMission.player.controllerName;
					local vehicle = nil;
					local currentVehicle = nil;
					
					for i=1, table.getn(g_currentMission.steerables) do
						if not g_currentMission.steerables[i].isBroken then
							vehicle = g_currentMission.steerables[i];
							if vehicle.isControlled and vehicle.controllerName == plyname then
								currentVehicle = vehicle;
								break;
							end;
						end;
					end;
					
					if currentVehicle ~= nil then
						local x,y,z = localDirectionToWorld(currentVehicle.rootNode, 0, 0, 1);
						local length = Utils.vector2Length(x,z);
						if (length ~= 0.0) then -- Try to make sure we do not divide by zero.
							local direction = math.deg(math.atan2(z/length,x/length)) + 90.0;   -- Rotate clockwise, so north=0, east=90, south=180, west=270.
							while (direction > 359.999999) do
								direction = direction - 360.0;
							end;
							while (direction < 0.0) do
								direction = direction + 360.0;
							end;

							local dirText = "";
							if     (direction >= 337.5    or  direction <  22.5   ) then  dirText = g_i18n:getText("north");       --"N";
							elseif (direction >=  22.5    and direction <  67.5   ) then  dirText = g_i18n:getText("northeast");   --"NE";
							elseif (direction >=  67.5    and direction < 112.5   ) then  dirText = g_i18n:getText("east");        --"E";
							elseif (direction >= 112.5    and direction < 157.5   ) then  dirText = g_i18n:getText("southeast");   --"SE";
							elseif (direction >= 157.5    and direction < 202.5   ) then  dirText = g_i18n:getText("south");       --"S";
							elseif (direction >= 202.5    and direction < 247.5   ) then  dirText = g_i18n:getText("southwest");   --"SW";
							elseif (direction >= 247.5    and direction < 292.5   ) then  dirText = g_i18n:getText("west");        --"W";
							elseif (direction >= 292.5    and direction < 337.5   ) then  dirText = g_i18n:getText("northwest");   --"NW";
							end;

							dirText = dirText .. string.format(" %6.2f", direction);
							-- setTextAlignment(RenderText.ALIGN_RIGHT);
							setTextBold(true);
							setTextColor(self.txtColors.compass.r, self.txtColors.compass.g, self.txtColors.compass.b, self.txtColors.compass.a);
							tY = self.cmPanel.position.y + self.cmPanel.files.fileComp.height/4
							-- + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data - self.cmPanel.fontsize.data;
							renderText(self.cmPanel.position.x + self.cmPanel.indent.compass,
										tY, self.cmPanel.fontsize.compass, 
										dirText);
							setTextBold(false);
							-- setTextAlignment(RenderText.ALIGN_LEFT);	
						end;
					end;
					
				end;
			end;
			----
		else	-- Kein Panel verwenden, Texte um die Uhr herum ausgeben
			----
			-- Datum ausgeben
			----
			setTextColor(self.txtColors.date.r, self.txtColors.date.g, self.txtColors.date.b, self.txtColors.date.a);
			renderText(0.83, 0.982, 0.02, self.cmPanel.text.Datetxt);
			----

			----
			-- Uhrzeit
			----
			setTextColor(self.txtColors.time.r, self.txtColors.time.g, self.txtColors.time.b, self.txtColors.time.a);
			renderText(0.87, 0.905, 0.018, self.cmPanel.text.Timetxt);
			----
			
			----
			-- Spielzeit zeigen / Show Playtime
			----
			setTextColor(self.txtColors.title.r, self.txtColors.title.g, self.txtColors.title.b, self.txtColors.title.a);
			renderText(0.83, 0.970, 0.013, self.cmPanel.title.PlayTimeAll);	
			renderText(0.83, 0.956, 0.013, self.cmPanel.title.PlayTimeToday);
			
			setTextColor(self.txtColors.data.r, self.txtColors.data.g, self.txtColors.data.b, self.txtColors.data.a);
			renderText(0.91, 0.970, 0.013, self.cmPanel.text.PlayTimeAll);		
			renderText(0.91, 0.957, 0.013, self.cmPanel.text.PlayTimeToday);		
			----
		end;
		----
	end;
	----
	setTextColor(1, 1, 1, 0);
end;

function ClockMod:mouseEvent(posX, posY, isDown, isUp, button)
	self:updatePanelOverlays();
	
	if self.dragHUD and self.cmPanel.hudCanMove then
		self.cmPanel.base.X = posX;
		self.cmPanel.base.Y = posY;
	end;
	-- HUD move
	local baseX = self.cmPanel.base.X;
	local baseY = self.cmPanel.base.Y;
	local cmWidth = self.cmPanel.position.w/2;
	local cmHeight = self.cmPanel.panelHeight/2;
	
	local HUDchanged = false;
	if self.dragHUD and isDown and button == 1 then
		self.dragHUD = false;
		--	print("dragHUD ist false | mouseEvent()");
		HUDchanged = true;
	end;
	if isDown and button == 1 and HUDchanged ~= true then
		----
		--	print("Prüfen der Mausklickposition | mouseEvent()");
		--	print(string.format("baseX (%s) / cmWidth (%s) / posX (%s)", tostring(baseX), tostring(cmWidth), tostring(posX)));
		--	print(string.format("baseY (%s) / cmHeight (%s) / posY (%s)", tostring(baseY), tostring(cmHeight), tostring(posY)));
		----
		if (baseX-cmWidth) < posX and posX < (baseX+cmWidth) and (baseY-cmHeight) < posY and posY < (baseY+cmHeight) then
			self.dragHUD = true;
			--	print("dragHUD ist true | mouseEvent()");
		end;
	end;
end;

function ClockMod:keyEvent(unicode, sym, modifier, isDown)

end;

function ClockMod:deleteMap()

end;

function ClockMod:reloadPanelOverlays()
	self:loadPanel(nil, true);
	self:updatePanelOverlays();
end;
function ClockMod:updatePanelOverlays()
	----
	--	Obere Panelgrafik
	----
	self.cmPanel.files.fileTop.overlayID = createImageOverlay(self.cmPanel.files.fileTop.file);
	if self.cmPanel.files.fileTop.overlayID ~= nil and self.cmPanel.files.fileTop.overlayID ~=0 then
		self.cmPanel.files.fileTop.valid = true;
	else
		print("Obere Panelgrafik ist ungültig");
		self.cmPanel.files.fileTop.valid = false;
	end;
	----
	
	----
	--	Mittlere Panelgrafik
	----
	self:setPanelMidHeight();
	----
	self.cmPanel.files.fileMid.overlayID = createImageOverlay(self.cmPanel.files.fileMid.file);
	if self.cmPanel.files.fileMid.overlayID ~= nil and self.cmPanel.files.fileMid.overlayID ~=0 then
		self.cmPanel.files.fileMid.valid = true;
	else
		print("Mittlere Panelgrafik ist ungültig");
		self.cmPanel.files.fileTop.valid = false;
	end;	
	----
	
	----
	--	Untere Panelgrafik
	----
	self.cmPanel.files.fileBot.overlayID = createImageOverlay(self.cmPanel.files.fileBot.file);
	if self.cmPanel.files.fileBot.overlayID ~= nil and self.cmPanel.files.fileBot.overlayID ~=0 then
		self.cmPanel.files.fileBot.valid = true;
	else
		print("Untere Panelgrafik ist ungültig");
		self.cmPanel.files.fileTop.valid = false;
	end;
	----
	
	----
	--	Untere Panelgrafik für Compass
	----
	self.cmPanel.files.fileComp.overlayID = createImageOverlay(self.cmPanel.files.fileComp.file);
	if self.cmPanel.files.fileComp.overlayID ~= nil and self.cmPanel.files.fileComp.overlayID ~=0 then
		self.cmPanel.files.fileComp.valid = true;
	end;
	----

	----
	--	Update der Base Position
	----
	self.cmPanel.panelHeight = self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height + self.cmPanel.files.fileTop.height;
	self.cmPanel.base.X = self.cmPanel.position.w/2 + self.cmPanel.position.x
	self.cmPanel.base.Y = self.cmPanel.panelHeight/2 + self.cmPanel.position.y
	----

end;

function ClockMod:setPanelMidHeight()
	--- Größe der mittleren Grafik abhängig von den Fontgrößen
	self.cmPanel.files.fileMid.height = self.cmPanel.fontsize.date + self.cmPanel.fontsize.time;
	if self.cmPanel.fontsize.title > self.cmPanel.fontsize.data then
		self.cmPanel.files.fileMid.height = self.cmPanel.files.fileMid.height + 2*self.cmPanel.fontsize.title;
	else
		self.cmPanel.files.fileMid.height = self.cmPanel.files.fileMid.height + 2*self.cmPanel.fontsize.data;
	end;
end;

function table.deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function table.show(t, name, indent)
   local cart     -- a container
   local autoref  -- for self references

   --[[ counts the number of elements in a table
   local function tablecount(t)
      local n = 0
      for _, _ in pairs(t) do n = n+1 end
      return n
   end
   ]]
   -- (RiciLake) returns true if the table is empty
   local function isemptytable(t) return next(t) == nil end

   local function basicSerialize (o)
      local so = tostring(o)
      if type(o) == "function" then
         local info = debug.getinfo(o, "S")
         -- info.name is nil because o is not a calling level
         if info.what == "C" then
            return string.format("%q", so .. ", C function")
         else 
            -- the information is defined through lines
            return string.format("%q", so .. ", defined in (" ..
                info.linedefined .. "-" .. info.lastlinedefined ..
                ")" .. info.source)
         end
      elseif type(o) == "number" then
         return so
      else
         return string.format("%q", so)
      end
   end
   local function addtocart (value, name, indent, saved, field)
      indent = indent or ""
      saved = saved or {}
      field = field or name

      cart = cart .. indent .. field

      if type(value) ~= "table" then
         cart = cart .. " = " .. basicSerialize(value) .. ";\n"
      else
         if saved[value] then
            cart = cart .. " = {}; -- " .. saved[value] 
                        .. " (self reference)\n"
            autoref = autoref ..  name .. " = " .. saved[value] .. ";\n"
         else
            saved[value] = name
            --if tablecount(value) == 0 then
            if isemptytable(value) then
               cart = cart .. " = {};\n"
            else
               cart = cart .. " = {\n"
               for k, v in pairs(value) do
                  k = basicSerialize(k)
                  local fname = string.format("%s[%s]", name, k)
                  field = string.format("[%s]", k)
                  -- three spaces between levels
                  addtocart(v, fname, indent .. "   ", saved, field)
               end
               cart = cart .. indent .. "};\n"
            end
         end
      end
   end

   name = name or "__unnamed__"
   if type(t) ~= "table" then
      return name .. " = " .. basicSerialize(t)
   end
   cart, autoref = "", ""
   addtocart(t, name, indent)
   return cart .. autoref
end

function table.tcopy(tab, parent, tDebug)
    local ret = {}
	-- Prüfen auf gültige Tabelle
	-- Abbrechen wenn NIL
	if tab == nil then 
		return nil;
	end;
	
    for key, value in pairs(tab) do
		if  tDebug ~= nil and tDebug == true then
			if parent ~= nil and type(parent) ~= "table" then 
				print(string.format("%s.%s=%s (%s)", parent, tostring(key), tostring(value), type(value)));
			elseif type(parent) ~= "table" then 
				print(string.format("%s=%s (%s)", tostring(key), tostring(value), type(value)));
			else
				print(string.format("%s=%s", tostring(key), type(value)));
			end;
		end;
		
        if (type(value) == "table") then 
			ret[key] = table.tcopy(value, key)
        else 
			ret[key] = value 
		end;
    end;
    return ret
end;

addModEventListener(ClockMod);
